## net.sf.saxon.instruct
Class Assign

    java.lang.Object
      net.sf.saxon.expr.ComputedExpression
          net.sf.saxon.instruct.Instruction
              net.sf.saxon.instruct.GeneralVariable
                  net.sf.saxon.instruct.Assign

All Implemented Interfaces:
  Binding, BindingReference, Container, Expression, InstructionInfoProvider, java.io.Serializable, javax.xml.transform.SourceLocator, TailCallReturner

public class Assign
extends GeneralVariable
implements BindingReference

saxon:assign element in stylesheet. The saxon:assign element has mandatory attribute name and optional attribute expr. It also allows xsl:extension-element-prefixes etc.

See Also:
  Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.instruct.GeneralVariable
`nameCode, referenceCount`

Fields inherited from class net.sf.saxon.expr.ComputedExpression
`locationId, staticProperties`

Fields inherited from interface net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, PROCESS_METHOD`

Constructor Summary
`Assign()`

Method Summary
`boolean` `createsNewNodes()` Determine whether this instruction creates new nodes.
`ValueRepresentation` `evaluateVariable(XPathContext context)` Evaluate the variable (method exists only to satisfy the interface)
`void` `fixup(Binding binding)` Fix up this binding reference to a binding
`int` `getInstructionNameCode()` Get the name of this instruction for diagnostic and tracing purposes
`TailCall` `processLeavingTail(XPathContext context)` ProcessLeavingTail: called to do the real work of this instruction.
`Expression` `promote(PromotionOffer offer)` Offer promotion for this subexpression.
`void` `setStaticType(SequenceType type, Value constantValue, int properties)` Fix up the static type of this variable reference; optionally, supply a constant value for the variable.

Methods inherited from class net.sf.saxon.instruct.GeneralVariable

`display, evaluateItem, getCardinality, getItemType, getLocalSlotNumber, getNameCode, getRequiredType, getSelectExpression, getSelectValue, getSlotNumber, getVariableFingerprint, getVariableName, init, isAssignable, isGlobal, isRequiredParam, isTunnelParam, iterate, iterateSubExpressions, optimize, promoteInst, setAssignable, setNameCode, setReferenceCount, setRequiredParam, setRequiredType, setSelectExpression, setSlotNumber, setTunnel, setVariableName, simplify, typeCheck`

Methods inherited from class net.sf.saxon.instruct.Instruction
`appendItem, assembleParams, assembleTunnelParams, computeCardinality, computeSpecialProperties, dynamicError, evaluateAsString, getImplementationMethod, getInstructionInfo, getSourceLocator, isXSLT, process`

Methods inherited from class net.sf.saxon.expr.ComputedExpression

`adoptChildExpression, checkPermittedContents, computeDependencies, computeStaticProperties, doPromotion, dynamicError, dynamicError, effectiveBooleanValue, getColumnNumber, getConstructType, getDependencies, getExecutable, getIntrinsicDependencies, getLineNumber, getLocationId, getLocationProvider, getParentExpression, getPublicId, getSlotsUsed, getSpecialProperties, getSystemId, hasBadParentPointer, markTailFunctionCalls, resetStaticProperties, setLocationId, setParentExpression, suppressValidation, typeError, typeError`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface javax.xml.transform.SourceLocator
`getColumnNumber, getLineNumber, getPublicId, getSystemId`

Constructor Detail

### Assign

    public Assign()

Method Detail

### setStaticType

    public void setStaticType(SequenceType type,
                              Value constantValue,
                              int properties)

  Description copied from interface: `BindingReference`
  Fix up the static type of this variable reference; optionally, supply a constant value for the variable. Also supplies other static properties of the expression to which the variable is bound, for example whether it is an ordered node-set.

  Specified by:
    `setStaticType` in interface `BindingReference`

### fixup

    public void fixup(Binding binding)

  Description copied from interface: `BindingReference`
  Fix up this binding reference to a binding

  Specified by:
    `fixup` in interface `BindingReference`

### createsNewNodes

    public final boolean createsNewNodes()

  Determine whether this instruction creates new nodes. This implementation returns true: although the instruction doesn't create new nodes, pretending that it does causes the optimizer to avoid pulling the instruction out of a loop.

  Overrides:
    `createsNewNodes` in class `Instruction`

### promote

    public Expression promote(PromotionOffer offer)
                       throws XPathException

  Offer promotion for this subexpression. This needs careful handling in the case of saxon:assign

  Specified by:
    `promote` in interface `Expression`
  Overrides:
    `promote` in class `Instruction`
  Parameters:
    `offer` - details of the offer, for example the offer to move expressions that don't depend on the context to an outer level in the containing expression
  Returns:
    if the offer is not accepted, return this expression unchanged. Otherwise return the result of rewriting the expression to promote this subexpression
  Throws:
    `XPathException` - if any error is detected

### getInstructionNameCode

    public int getInstructionNameCode()

  Get the name of this instruction for diagnostic and tracing purposes

  Overrides:
    `getInstructionNameCode` in class `GeneralVariable`

### processLeavingTail

    public TailCall processLeavingTail(XPathContext context)
                                throws XPathException

  Description copied from class: `Instruction`
  ProcessLeavingTail: called to do the real work of this instruction. This method must be implemented in each subclass. The results of the instruction are written to the current Receiver, which can be obtained via the Controller.

  Specified by:
    `processLeavingTail` in interface `TailCallReturner`
  Specified by:
    `processLeavingTail` in class `Instruction`
  Parameters:
    `context` - The dynamic context of the transformation, giving access to the current node, the current variables, etc.
  Returns:
    null if the instruction has completed execution; or a TailCall indicating a function call or template call that is delegated to the caller, to be made after the stack has been unwound so as to save stack space.
  Throws:
    `XPathException`

### evaluateVariable

    public ValueRepresentation evaluateVariable(XPathContext context)
                                         throws XPathException

  Evaluate the variable (method exists only to satisfy the interface)

  Specified by:
    `evaluateVariable` in interface `Binding`
  Throws:
    `XPathException`